<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>AdminLTE 3 | Blank Page</title>

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <!-- DataTables -->
    <link rel="stylesheet" href="plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
    <link rel="stylesheet" href="plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">


</head>

<body class="hold-transition sidebar-mini">
    <!-- Site wrapper -->
    <div class="wrapper">
        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="index3.html" class="nav-link">Home</a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="#" class="nav-link">Contact</a>
                </li>
            </ul>


        </nav>
        <!-- /.navbar -->

        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="index3.html" class="brand-link">
                <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
                    style="opacity: .8">
                <span class="brand-text font-weight-light">Task 49.10</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <!-- Sidebar user (optional) -->
                <div class="user-panel mt-3 pb-3 mb-3 d-flex">
                    <div class="image">
                        <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
                    </div>
                    <div class="info">
                        <a href="#" class="d-block">Baodtg</a>
                    </div>
                </div>
                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
                        <li class="nav-item menu-open">
                            <a href="#" class="nav-link active">
                                <i class="nav-icon fas fa-tachometer-alt"></i>
                                <p>
                                    Chart & Advance form
                                    <i class="right fas fa-angle-left"></i>
                                </p>
                            </a>
                            <ul class="nav nav-treeview">
                                <li class="nav-item">
                                    <a href="chartjs.html" class="nav-link active">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Contact Table</p>
                                    </a>
                                </li>

                            </ul>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>

        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <section class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6">
                            <h1>Contact Table</h1>
                        </div>
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active">Blank Page</li>
                            </ol>
                        </div>
                    </div>
                </div><!-- /.container-fluid -->
            </section>

            <!-- Main content -->
            <section class="content">
                <div>
                    <button class="btn btn-success mb-5" id="btn-them-contact">Add contact</button>
                    <table class="table sm table-stripped table-hover table-bordered table-success"
                        id="contacts-data-table">
                        <thead>
                            <tr>
                                <td>STT</td>
                                <td>Name</td>
                                <td>Email</td>
                                <td>Message</td>
                                <td>Date</td>
                                <td>Action</td>

                            </tr>
                        </thead>
                    </table>
                </div>
                <!-- Vùng Modal -->

                <!-- Create contact modal -->
                <div>
                    <div id="create-contact-modal" class="modal fade" tabindex="-1">
                        <div class="modal-dialog">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title" id="h5-modal-title">Create new contact</h5>
                                    <button class="close" data-dismiss="modal">&times;</button>
                                </div>
                                <div class="modal-body">
                                    <form>
                                        <div class="row form-group">
                                            <div class="col-sm-4">
                                                <label>Name</label>
                                            </div>
                                            <div class="col-sm-8">
                                                <input type="text" id="inp-name" class="form-control">
                                            </div>
                                        </div>
                                        <div class="row form-group">
                                            <div class="col-sm-4">
                                                <label>Email</label>
                                            </div>
                                            <div class="col-sm-8">
                                                <input type="email" id="inp-email" class="form-control">
                                            </div>
                                        </div>
                                        <div class="row form-group">
                                            <div class="col-sm-4">
                                                <label>Message</label>
                                            </div>
                                            <div class="col-sm-8">
                                                <input type="text" id="inp-message" class="form-control">
                                            </div>
                                        </div>
                                        <div class="row form-group">
                                            <div class="col-sm-4">
                                                <label for="inp-date" class="col-form-label ">Ngày liên hệ</label>
                                            </div>
                                            <div class="col-sm-8">
                                                <input type="text" class="form-control transparent-background"
                                                    id="inp-date" readonly>
                                            </div>

                                        </div>
                                    </form>
                                </div>
                                <div class="modal-footer">
                                    <button class="btn btn-secondary" id="btn-create-cancel"
                                        data-dismiss="modal">Cancel</button>
                                    <button class="btn btn-primary" id="btn-create-contact">Create Contact</button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <!-- Update contact modal -->
                <div>
                    <div id="update-contact-modal" class="modal fade" tabindex="-1">
                        <div class="modal-dialog">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title" id="h5-modal-title">Update Contact</h5>
                                    <button class="close" data-dismiss="modal">&times;</button>
                                </div>
                                <div class="modal-body">
                                    <form>
                                        <div class="row form-group">
                                            <div class="col-sm-4">
                                                <label>Name</label>
                                            </div>
                                            <div class="col-sm-8">
                                                <input type="text" id="input-name" class="form-control">
                                            </div>
                                        </div>
                                        <div class="row form-group">
                                            <div class="col-sm-4">
                                                <label>Email</label>
                                            </div>
                                            <div class="col-sm-8">
                                                <input type="email" id="input-email" class="form-control">
                                            </div>
                                        </div>
                                        <div class="row form-group">
                                            <div class="col-sm-4">
                                                <label>Message</label>
                                            </div>
                                            <div class="col-sm-8">
                                                <input type="text" id="input-message" class="form-control">
                                            </div>
                                        </div>
                                        <div class="row form-group">
                                            <div class="col-sm-4">
                                                <label for="inp-date" class="col-form-label ">Ngày liên hệ</label>
                                            </div>
                                            <div class="col-sm-8">
                                                <input type="text" class="form-control transparent-background"
                                                    id="input-date" readonly>
                                            </div>
                                        </div>
                                    </form>
                                </div>
                                <div class="modal-footer">
                                    <button class="btn btn-secondary" id="btn-update-cancel"
                                        data-dismiss="modal">Cancel</button>
                                    <button class="btn btn-primary" id="btn-update-contact">Update Contact</button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- Delete confirm modal -->
                <div>
                    <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
                        <div class="modal-dialog">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title" id="h5-modal-title">Delete Contact Confirmation</h5>
                                    <button class="close" data-dismiss="modal">&times;</button>
                                </div>
                                <div class="modal-body">
                                    <label>Bạn có chắc chắn muốn xóa contact này không?</label>
                                </div>
                                <div class="modal-footer">
                                    <button class="btn btn-danger" id="btn-confirm-delete-contact">Confirm</button>
                                    <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </section>
            <!-- /.content -->
        </div>
        <!-- /.content-wrapper -->

        <footer class="main-footer">
            <div class="float-right d-none d-sm-block">
                <b>Version</b> 3.2.0
            </div>
            <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights
            reserved.
        </footer>

        <!-- Control Sidebar -->
        <aside class="control-sidebar control-sidebar-dark">
            <!-- Control sidebar content goes here -->
        </aside>
        <!-- /.control-sidebar -->
    </div>
    <!-- ./wrapper -->

    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>
    <!-- DataTables  & Plugins -->
    <script src="plugins/datatables/jquery.dataTables.min.js"></script>
    <script src="plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
    <script src="plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
    <script src="plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
    <script src="plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
    <script src="plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
    <script src="plugins/jszip/jszip.min.js"></script>
    <script src="plugins/pdfmake/pdfmake.min.js"></script>
    <script src="plugins/pdfmake/vfs_fonts.js"></script>
    <script src="plugins/datatables-buttons/js/buttons.html5.min.js"></script>
    <script src="plugins/datatables-buttons/js/buttons.print.min.js"></script>
    <script src="plugins/datatables-buttons/js/buttons.colVis.min.js"></script>

</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gBASE_URL = "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/";
    var gSTT = 1;
    const gCONTENT_TYPE = "application/json;charset=UTF-8";
    // Biến mảng hằng số chứa danh sách tên các thuộc tính
    const gCONTACT_COLS = [
        "stt",
        "name",
        "email",
        "message",
        "createDate",
        "id"
    ];


    var gDataContactsArray = [];
    var gContactsDataTable = $("#contacts-data-table").DataTable({
        data: gDataContactsArray,
        columns: [
            { data: "id" },
            { data: "name" },
            { data: "email" },
            { data: "message" },
            { data: "createDate" },
            { data: "action" },

        ],
        columnDefs: [
            {
                targets: 0,
                render: function () {
                    return gSTT++
                }
            },
            {
                targets: 5,
                "defaultContent": `<i class="far fa-edit text-primary edit-contact" id="btn-edit-contact" style="font-size: 20px; cursor: pointer;" data-toggle="tooltip" title="Edit Pet"></i>&nbsp; 
                <i class="fas fa-trash-alt text-danger delete-contact" id="btn-delete-contact" style="font-size: 20px; cursor: pointer;" title="Delete Pet" data-toggle="modal" data-target="#modal-delete-pet"></i>
                `
            },
        ]
    });
    // Biến toàn cục để lưu các mảng giá trị
    var gContactArray = [];
    // Biến toàn cục để lưu id contact
    var gContactId = 0;
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    onPageLoading();
    // 2 - C: gán sự kiện Create - Thêm mới contact
    $("#btn-them-contact").on("click", function () {
        onBtnAddNewContactClick();
    });
    // 3 - U: gán sự kiện Update - Sửa 1 contact
    $("#contacts-data-table").on("click", ".edit-contact", function () {
        onBtnEditContactClick(this);
    });
    // 4 - D: gán sự kiện delete - Xóa 1 contact
    $("#contacts-data-table").on("click", ".delete-contact", function () {
        onBtnDeleteContactClick(this);
    });
    //phần modal
    // gán sự kiện cho nút Create Contact (trên modal)
    $("#btn-create-contact").on("click", function () {
        onBtnCreateContactClick();
    });
    // gán sự kiện cho nút Update Contact (trên modal)
    $("#btn-update-contact").on("click", function () {
        onBtnUpdateContactClick();
    });
    // Gán sự kiện cho nút Confirm Delete Contact (trên modal)
    $("#btn-confirm-delete-contact").on("click", function () {
        onBtnConfirmDeleteContactClick();
    });



    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        getAllContact()
    }
    // Hàm xử lý sự kiện khi nút Thêm mới đc click
    function onBtnAddNewContactClick() {
        // hiển thị modal trắng lên
        $("#create-contact-modal").modal("show");
    }
    // hàm xử lý sự kiện create contact button modal click
    function onBtnCreateContactClick() {
        // đối tượng contact sẽ được tạo mới
        var vContactObj = {
            name: "",
            email: "",
            message: "",
            createDate: ""
        };
        // B1: Thu thập dữ liệu
        getCreateContactData(vContactObj);
        console.log(vContactObj);
        // B2: Validate insert
        var vIsContactValidate = validateContactData(vContactObj);
        if (vIsContactValidate) {
            // B3: insert contact
            $.ajax({
                url: gBASE_URL + "/contacts",
                type: "POST",
                contentType: gCONTENT_TYPE,
                data: JSON.stringify(vContactObj),
                success: function (paramRes) {
                    // B4: xử lý front-end
                    handleInsertContactSuccess()
                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            });
        }
    }

    function onBtnEditContactClick(paramBtnEdit) {
        // // lưu thông tin contactID đang được edit vào biến toàn cục
        // gContactId = $(paramBtnEdit).data("id");
        // console.log(gContactId);
        // $("#update-contact-modal").modal("show");
        // // load dữ liệu vào các trường dữ liệu trong modal
        // getContactByIdAndLoadToUpdateModal(gContactId);
        var vTableRow = $(paramBtnEdit).parents("tr");
        var vDataTableRow = gContactsDataTable.row(vTableRow);
        var vContactData = vDataTableRow.data();
        gContactId = vContactData.id;
        loadDataToUpdateModal(vContactData);
        $("#update-contact-modal").modal("show");
    }
    function onBtnDeleteContactClick(paramBtnDelete) {
        //lưu thông tin contactId đang được edit vào biến
        var vTableRow = $(paramBtnDelete).parents("tr");
        var vDataTableRow = gContactsDataTable.row(vTableRow);
        var vContactData = vDataTableRow.data();
        gContactId = vContactData.id;
        $("#delete-confirm-modal").modal("show");
    }

    // hàm xử lý sự kiện update contact modal click
    function onBtnUpdateContactClick() {
        // đối tượng contact sẽ được sửa
        var vContactObj = {
            name: "",
            email: "",
            message: "",
            createDate: ""
        };
        // B1: Thu thập dữ liệu
        getUpdateContactData(vContactObj);
        console.log(vContactObj);
        // B2: Validate update
        var vIsContactValidate = validateContactData(vContactObj);
        if (vIsContactValidate) {
            // B3: update contact
            $.ajax({
                url: gBASE_URL + "/contacts/" + gContactId,
                type: "PUT",
                contentType: gCONTENT_TYPE,
                data: JSON.stringify(vContactObj),
                success: function (paramRes) {
                    // B4: xử lý front-end
                    handleUpdateContactSuccess();
                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            });
        }
    }
    // hàm xử lý sự kiện delete contact modal click
    function onBtnConfirmDeleteContactClick() {
        "use strict";
        $.ajax({
            url: gBASE_URL + "/contacts/" + gContactId,
            type: "DELETE",
            success: function (paramRes) {
                // B4: xử lý front-end
                handleDeleteContactSuccess();
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }
        });
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function getAllContact() {
        $.ajax({
            url: gBASE_URL + "/contacts",
            type: "GET",
            success: function (paramRes) {
                console.log(paramRes);
                gDataContactsArray = paramRes;
                gContactsDataTable.rows.add(gDataContactsArray);
                gContactsDataTable.draw()
            },
            error: function (paramError) {
                console.log(paramError.reponseText)
            }
        });
    }
    /** load Contact array to DataTable */
    function loadDataToProductTable(paramContactArray) {
        gSTT = 1;
        gContactTable.clear();
        gContactTable.rows.add(paramContactArray);
        gContactTable.draw();
    }
    // hàm thu thập dữ liệu để create contact
    function getCreateContactData(paramContactObj) {
        paramContactObj.name = $("#inp-name").val().trim();
        paramContactObj.email = $("#inp-email").val().trim();
        paramContactObj.message = $("#inp-message").val().trim();
        paramContactObj.createDate = getDateToday();
    }
    // hàm validate data
    function validateContactData(paramContactObj) {
        if (paramContactObj.name == "") {
            alert("name cần nhập");
            return false;
        }
        if (paramContactObj.email == "") {
            alert("email cần nhập");
            return false;
        }
        if (paramContactObj.message == "") {
            alert("Message cần nhập");
            return false;
        }
        if (ValidateEmail(paramContactObj.email) == false) {
            alert("Email sai định dạng!");
            return false;
        }
        return true;
    }

    function getDateToday() {
        var vToday = new Date();
        var vDay = vToday.getDate();
        var vMonth = vToday.getMonth() + 1;
        var vYear = vToday.getFullYear();
        if (vDay < 10) {
            vDay = '0' + vDay;
        }
        if (vMonth < 10) {
            vMonth = '0' + vMonth;
        }
        vToday = vDay + '/' + vMonth + '/' + vYear;
        return vToday;
    }
    function ValidateEmail(paramEmail) {
        var vRegex = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|.(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        if (paramEmail.match(vRegex)) {
            return true;
        }
        else
            return false;
    }

    // hàm xử lý hiển thị front-end khi thêm Contact thành công
    function handleInsertContactSuccess() {
        alert("Thêm contact thành công!");
        getAllContact();
        resertCreateContactForm();
        $("#create-contact-modal").modal("hide");
    }
    // hàm xóa trắng form create contact
    function resertCreateContactForm() {
        $("#inp-name").val();
        $("#inp-email").val();
        $("#inp-message").val();
        $("#inp-date").val();
    }
    // hàm show contact obj lên modal
    function loadDataToUpdateModal(paramContact) {
        $("#input-name").val(paramContact.name);
        $("#input-email").val(paramContact.email);
        $("#input-message").val(paramContact.message);
        $("#input-date").val(paramContact.createDate);
    }

    // hàm thu thập dữ liệu để update contact
    function getUpdateContactData(paramContactObj) {
        paramContactObj.name = $("#input-name").val().trim();
        paramContactObj.email = $("#input-email").val().trim();
        paramContactObj.message = $("#input-message").val();
        paramContactObj.createDate = getDateToday;
    }
    // hàm xử lý hiển thị front-end khi sửa contact thành công
    function handleUpdateContactSuccess() {
        alert("Sửa contact thành công!");
        resertUpdateContactForm();
        $("#update-contact-modal").modal("hide");
        location.reload()
    }
    // hàm xóa trắng form update contact
    function resertUpdateContactForm() {
        $("#input-name").val();
        $("#input-email").val();
        $("#input-message").val();
        $("#input-date").val();
    }
    function handleDeleteContactSuccess() {
        // Hàm xử lý hiển thị front-end khi xóa contact thành công
        alert("Xóa contact thành công!");
        $("#delete-confirm-modal").modal("hide");
        location.reload()
    }



</script>

</html>